searchData={"items":[{"type":"module","doc":"When file or other input to too large for the model's context window, this\nmodule may be used to process the file in chunks. It automatically modifies\nthe supplied agent prompt to include instructions for accumulating a response\nacross multiple chunks based on the `context` (max context window tokens)\nparameter supplied by the `model` parameter.\n\nNote that while this makes use of the `AI.Completion` module, it does NOT\nhave the same interface and cannot be used for long-running conversations, as\nit does not accept a list of messages as its input.","title":"AI.Accumulator","ref":"AI.Accumulator.html"},{"type":"type","doc":"","title":"AI.Accumulator.error/0","ref":"AI.Accumulator.html#t:error/0"},{"type":"function","doc":"","title":"AI.Accumulator.get_response/1","ref":"AI.Accumulator.html#get_response/1"},{"type":"type","doc":"","title":"AI.Accumulator.response/0","ref":"AI.Accumulator.html#t:response/0"},{"type":"type","doc":"","title":"AI.Accumulator.success/0","ref":"AI.Accumulator.html#t:success/0"},{"type":"behaviour","doc":"","title":"AI.Agent","ref":"AI.Agent.html"},{"type":"type","doc":"","title":"AI.Agent.error/0","ref":"AI.Agent.html#t:error/0"},{"type":"callback","doc":"","title":"AI.Agent.get_response/1","ref":"AI.Agent.html#c:get_response/1"},{"type":"type","doc":"","title":"AI.Agent.response/0","ref":"AI.Agent.html#t:response/0"},{"type":"module","doc":"","title":"AI.Agent.Archivist","ref":"AI.Agent.Archivist.html"},{"type":"module","doc":"","title":"AI.Agent.CodeMapper","ref":"AI.Agent.CodeMapper.html"},{"type":"module","doc":"This agent uses a combination of the reasoning features of the OpenAI o3-mini\nmodel as well as its own reasoning process to research and answer the input\nquestion.\n\nIt is able to use most of the tools available and will save notes for future\nuse before finalizing its response.","title":"AI.Agent.Coordinator","ref":"AI.Agent.Coordinator.html"},{"type":"module","doc":"","title":"AI.Agent.Default","ref":"AI.Agent.Default.html"},{"type":"function","doc":"","title":"AI.Agent.Default.model/0","ref":"AI.Agent.Default.html#model/0"},{"type":"module","doc":"","title":"AI.Agent.Default.Classifier","ref":"AI.Agent.Default.Classifier.html"},{"type":"module","doc":"","title":"AI.Agent.Default.Rollups","ref":"AI.Agent.Default.Rollups.html"},{"type":"module","doc":"","title":"AI.Agent.FileInfo","ref":"AI.Agent.FileInfo.html"},{"type":"module","doc":"This module provides an agent that summarizes files' contents in order to\ngenerate embeddings for the database and summaries for the user.","title":"AI.Agent.FileSummary","ref":"AI.Agent.FileSummary.html"},{"type":"module","doc":"","title":"AI.Agent.Researcher","ref":"AI.Agent.Researcher.html"},{"type":"module","doc":"","title":"AI.Agent.Spelunker","ref":"AI.Agent.Spelunker.html"},{"type":"module","doc":"","title":"AI.ChatCompletion","ref":"AI.ChatCompletion.html"},{"type":"function","doc":"","title":"AI.ChatCompletion.get/3","ref":"AI.ChatCompletion.html#get/3"},{"type":"type","doc":"","title":"AI.ChatCompletion.model/0","ref":"AI.ChatCompletion.html#t:model/0"},{"type":"type","doc":"","title":"AI.ChatCompletion.msg_response/0","ref":"AI.ChatCompletion.html#t:msg_response/0"},{"type":"type","doc":"","title":"AI.ChatCompletion.msgs/0","ref":"AI.ChatCompletion.html#t:msgs/0"},{"type":"type","doc":"","title":"AI.ChatCompletion.response/0","ref":"AI.ChatCompletion.html#t:response/0"},{"type":"type","doc":"","title":"AI.ChatCompletion.tool_response/0","ref":"AI.ChatCompletion.html#t:tool_response/0"},{"type":"type","doc":"","title":"AI.ChatCompletion.tools/0","ref":"AI.ChatCompletion.html#t:tools/0"},{"type":"type","doc":"","title":"AI.ChatCompletion.usage/0","ref":"AI.ChatCompletion.html#t:usage/0"},{"type":"module","doc":"This module sends a request to the model and handles the response. It is able\nto handle tool calls and responses.","title":"AI.Completion","ref":"AI.Completion.html"},{"type":"module","doc":"Output is controlled by the following mechanisms.\n\n1. `log_msgs` - log messages from the user and assistant as `info`\n2. `log_tool_calls` - log tool calls as `info` and tool call results as `debug`\n\n`LOGGER_LEVEL` must be set to `debug` to see the output of tool call results.","title":"Output options - AI.Completion","ref":"AI.Completion.html#module-output-options"},{"type":"function","doc":"","title":"AI.Completion.get/1","ref":"AI.Completion.html#get/1"},{"type":"function","doc":"","title":"AI.Completion.handle_tool_call/2","ref":"AI.Completion.html#handle_tool_call/2"},{"type":"function","doc":"","title":"AI.Completion.new/1","ref":"AI.Completion.html#new/1"},{"type":"function","doc":"","title":"AI.Completion.new_from_conversation/2","ref":"AI.Completion.html#new_from_conversation/2"},{"type":"type","doc":"","title":"AI.Completion.response/0","ref":"AI.Completion.html#t:response/0"},{"type":"type","doc":"","title":"AI.Completion.t/0","ref":"AI.Completion.html#t:t/0"},{"type":"function","doc":"","title":"AI.Completion.tools_used/1","ref":"AI.Completion.html#tools_used/1"},{"type":"module","doc":"","title":"AI.Completion.Output","ref":"AI.Completion.Output.html"},{"type":"function","doc":"","title":"AI.Completion.Output.log_assistant_msg/2","ref":"AI.Completion.Output.html#log_assistant_msg/2"},{"type":"function","doc":"","title":"AI.Completion.Output.log_tool_call/2","ref":"AI.Completion.Output.html#log_tool_call/2"},{"type":"function","doc":"","title":"AI.Completion.Output.log_tool_call/3","ref":"AI.Completion.Output.html#log_tool_call/3"},{"type":"function","doc":"","title":"AI.Completion.Output.log_tool_call_error/3","ref":"AI.Completion.Output.html#log_tool_call_error/3"},{"type":"function","doc":"","title":"AI.Completion.Output.log_tool_call_result/2","ref":"AI.Completion.Output.html#log_tool_call_result/2"},{"type":"function","doc":"","title":"AI.Completion.Output.log_tool_call_result/3","ref":"AI.Completion.Output.html#log_tool_call_result/3"},{"type":"function","doc":"","title":"AI.Completion.Output.log_user_msg/2","ref":"AI.Completion.Output.html#log_user_msg/2"},{"type":"function","doc":"","title":"AI.Completion.Output.on_event/3","ref":"AI.Completion.Output.html#on_event/3"},{"type":"function","doc":"Replays an earlier conversation identically to the original interaction,\nexcept that the final response is logged as a typical assistant message, so\nthat the conversation may be continued.","title":"AI.Completion.Output.replay_conversation/1","ref":"AI.Completion.Output.html#replay_conversation/1"},{"type":"function","doc":"Replaces the entire conversation, similarly to `replay_conversation/1`, but\nprints the final message to STDOUT, identically to the original interaction.\nThis is intended to be used when replaying the entire conversation to\nreplicate the original interaction, rather than for the sake of continuing\nthe conversation to refine output.","title":"AI.Completion.Output.replay_conversation_as_output/1","ref":"AI.Completion.Output.html#replay_conversation_as_output/1"},{"type":"module","doc":"","title":"AI.Embeddings","ref":"AI.Embeddings.html"},{"type":"type","doc":"","title":"AI.Embeddings.embedding/0","ref":"AI.Embeddings.html#t:embedding/0"},{"type":"type","doc":"","title":"AI.Embeddings.embeddings/0","ref":"AI.Embeddings.html#t:embeddings/0"},{"type":"type","doc":"","title":"AI.Embeddings.error/0","ref":"AI.Embeddings.html#t:error/0"},{"type":"function","doc":"","title":"AI.Embeddings.get/1","ref":"AI.Embeddings.html#get/1"},{"type":"module","doc":"","title":"AI.Model","ref":"AI.Model.html"},{"type":"function","doc":"","title":"AI.Model.balanced/0","ref":"AI.Model.html#balanced/0"},{"type":"function","doc":"","title":"AI.Model.fast/0","ref":"AI.Model.html#fast/0"},{"type":"function","doc":"","title":"AI.Model.new/2","ref":"AI.Model.html#new/2"},{"type":"function","doc":"","title":"AI.Model.smart/0","ref":"AI.Model.html#smart/0"},{"type":"type","doc":"","title":"AI.Model.t/0","ref":"AI.Model.html#t:t/0"},{"type":"module","doc":"OpenAI's tokenizer uses regexes that are not compatible with Erlang's regex\nengine. There are a couple of modules available on hex, but all of them\nrequire a working python installation, access to rustc, a number of external\ndependencies, and some env flags set to allow it to compile.\n\nRather than impose that on end users, this module guesstimates token counts\nbased on OpenAI's assertion that 1 token is approximately 4 characters.\nCallers must take that into account when selecting their chunk size,\nincluding some amount of buffer to account for the inaccuracy of this\napproximation.","title":"AI.PretendTokenizer","ref":"AI.PretendTokenizer.html"},{"type":"function","doc":"","title":"AI.PretendTokenizer.chunk/3","ref":"AI.PretendTokenizer.html#chunk/3"},{"type":"type","doc":"","title":"AI.PretendTokenizer.chunk_size/0","ref":"AI.PretendTokenizer.html#t:chunk_size/0"},{"type":"type","doc":"","title":"AI.PretendTokenizer.chunked_input/0","ref":"AI.PretendTokenizer.html#t:chunked_input/0"},{"type":"function","doc":"","title":"AI.PretendTokenizer.guesstimate_tokens/1","ref":"AI.PretendTokenizer.html#guesstimate_tokens/1"},{"type":"type","doc":"","title":"AI.PretendTokenizer.input/0","ref":"AI.PretendTokenizer.html#t:input/0"},{"type":"function","doc":"","title":"AI.PretendTokenizer.over_max_for_openai_embeddings?/1","ref":"AI.PretendTokenizer.html#over_max_for_openai_embeddings?/1"},{"type":"type","doc":"","title":"AI.PretendTokenizer.reduction_factor/0","ref":"AI.PretendTokenizer.html#t:reduction_factor/0"},{"type":"module","doc":"This module is used to split a string into chunks by the number of tokens,\nwhile accounting for *other* data that might be going with it to the API\nendpoint with the limited token count.\n\nFor example, the search entry agent may be processing a large file, one that\nmust be split into 3 slices just to fit it into the payload of an API call.\nIn order to retain context between chunks, the agent essentially _reduces_\nover the file, keeping track of information in the previous chunks to\ngenerate a final summary. Doing that means that we need to not only split the\nfile by the number of tokens in each slice, but also keep some space for the\nbespoke data that will be added to the payload as the agent's \"accumulator\".","title":"AI.Splitter","ref":"AI.Splitter.html"},{"type":"function","doc":"","title":"AI.Splitter.new/2","ref":"AI.Splitter.html#new/2"},{"type":"function","doc":"","title":"AI.Splitter.next_chunk/2","ref":"AI.Splitter.html#next_chunk/2"},{"type":"behaviour","doc":"This module defines the behaviour for tool calls. Defining a new tool\nrequires implementing the `spec/0` and `call/2` functions.\n\nThe `spec/0` function should return a map that describes the tool's\ncapabilities and arguments, using a map to represent the OpenAPI spec.\n\nThe `call/2` function generates the tool call response. It accepts the\nrequesting `AI.Completion`'s struct and a map derived from the parsed JSON\nprovided by the agent, containing the tool call arguments. Note that, because\nthe arguments are parsed from JSON, the keys will all be strings. Whether\nthose are converted to symbols is between the tool implementation and the\ncode it calls. What happens behind closed APIs is none of MY business.","title":"AI.Tools","ref":"AI.Tools.html"},{"type":"behaviour","doc":"```elixir\ndefmodule AI.Tools.MyNewTool do\n  @behaviour AI.Tools\n\n  @impl AI.Tools\n  def ui_note_on_request(_args) do\n    {\"Doing something\", \"This tool is doing something.\"}\n  end\n\n  @impl AI.Tools\n  def ui_note_on_result(_args, _result) do\n    {\"Did something\", \"This tool did something.\"}\n  end\n\n  @impl AI.Tools\n  def read_args(args) do\n    {:ok, args}\n  end\n\n  @impl AI.Tools\n  def spec() do\n    %{\n      type: \"function\",\n      function: %{\n        name: \"something_tool\",\n        description: \"This tool does something.\",\n        strict: true,\n        parameters: %{\n          additionalProperties: false,\n          type: \"object\",\n          required: [\"thing\"],\n          properties: %{\n            thing: %{\n              type: \"string\",\n              description: \"The thing to do.\"\n            }\n          }\n        }\n      }\n    }\n  end\n\n  @impl AI.Tools\n  def call(args) do\n    {:ok, \"IMPLEMENT ME\"}\n  end\nend\n```","title":"Skeleton Implementation - AI.Tools","ref":"AI.Tools.html#module-skeleton-implementation"},{"type":"function","doc":"","title":"AI.Tools.all_tool_specs_for_project/1","ref":"AI.Tools.html#all_tool_specs_for_project/1"},{"type":"function","doc":"","title":"AI.Tools.all_tools/1","ref":"AI.Tools.html#all_tools/1"},{"type":"type","doc":"","title":"AI.Tools.args_error/0","ref":"AI.Tools.html#t:args_error/0"},{"type":"callback","doc":"Calls the tool with the provided arguments and returns the response as an :ok\ntuple.","title":"AI.Tools.call/1","ref":"AI.Tools.html#c:call/1"},{"type":"function","doc":"","title":"AI.Tools.get_entry/1","ref":"AI.Tools.html#get_entry/1"},{"type":"function","doc":"","title":"AI.Tools.get_entry/2","ref":"AI.Tools.html#get_entry/2"},{"type":"function","doc":"","title":"AI.Tools.get_file_contents/1","ref":"AI.Tools.html#get_file_contents/1"},{"type":"function","doc":"","title":"AI.Tools.get_project/0","ref":"AI.Tools.html#get_project/0"},{"type":"function","doc":"","title":"AI.Tools.on_tool_request/3","ref":"AI.Tools.html#on_tool_request/3"},{"type":"function","doc":"","title":"AI.Tools.on_tool_result/4","ref":"AI.Tools.html#on_tool_result/4"},{"type":"function","doc":"","title":"AI.Tools.perform_tool_call/3","ref":"AI.Tools.html#perform_tool_call/3"},{"type":"callback","doc":"Reads the arguments and returns a map of the arguments if they are valid.\nThis is used to validate args before the tool is called. The result is what\nis passed to `call/2`, `ui_note_on_request/1`, and `ui_note_on_result/2`.","title":"AI.Tools.read_args/1","ref":"AI.Tools.html#c:read_args/1"},{"type":"function","doc":"","title":"AI.Tools.required_arg_error/1","ref":"AI.Tools.html#required_arg_error/1"},{"type":"callback","doc":"Returns the OpenAPI spec for the tool as an elixir map.","title":"AI.Tools.spec/0","ref":"AI.Tools.html#c:spec/0"},{"type":"function","doc":"","title":"AI.Tools.tool_module/2","ref":"AI.Tools.html#tool_module/2"},{"type":"type","doc":"","title":"AI.Tools.tool_spec/0","ref":"AI.Tools.html#t:tool_spec/0"},{"type":"function","doc":"","title":"AI.Tools.tool_spec/2","ref":"AI.Tools.html#tool_spec/2"},{"type":"function","doc":"","title":"AI.Tools.tool_spec!/2","ref":"AI.Tools.html#tool_spec!/2"},{"type":"function","doc":"","title":"AI.Tools.tools/0","ref":"AI.Tools.html#tools/0"},{"type":"callback","doc":"Return either a short string or a string tuple of label + detail to be\ndisplayed when the tool is called.","title":"AI.Tools.ui_note_on_request/1","ref":"AI.Tools.html#c:ui_note_on_request/1"},{"type":"callback","doc":"Return either a short string or a string tuple of label + detail to be\ndisplayed when the tool call is successful.","title":"AI.Tools.ui_note_on_result/2","ref":"AI.Tools.html#c:ui_note_on_result/2"},{"type":"function","doc":"","title":"AI.Tools.validate_required_args/3","ref":"AI.Tools.html#validate_required_args/3"},{"type":"function","doc":"","title":"AI.Tools.with_args/4","ref":"AI.Tools.html#with_args/4"},{"type":"module","doc":"","title":"AI.Tools.Default.Notes","ref":"AI.Tools.Default.Notes.html"},{"type":"module","doc":"","title":"AI.Tools.Default.Prompt","ref":"AI.Tools.Default.Prompt.html"},{"type":"module","doc":"","title":"AI.Tools.File.Contents","ref":"AI.Tools.File.Contents.html"},{"type":"module","doc":"","title":"AI.Tools.File.Info","ref":"AI.Tools.File.Info.html"},{"type":"module","doc":"","title":"AI.Tools.File.List","ref":"AI.Tools.File.List.html"},{"type":"module","doc":"","title":"AI.Tools.File.Outline","ref":"AI.Tools.File.Outline.html"},{"type":"module","doc":"","title":"AI.Tools.File.Search","ref":"AI.Tools.File.Search.html"},{"type":"function","doc":"This tool requires that the project has been indexed to use. If the project\nhas not been indexed, the tool should not be made available.","title":"AI.Tools.File.Search.is_available?/0","ref":"AI.Tools.File.Search.html#is_available?/0"},{"type":"module","doc":"","title":"AI.Tools.File.Spelunker","ref":"AI.Tools.File.Spelunker.html"},{"type":"module","doc":"","title":"AI.Tools.Git.DiffBranch","ref":"AI.Tools.Git.DiffBranch.html"},{"type":"module","doc":"","title":"AI.Tools.Git.Grep","ref":"AI.Tools.Git.Grep.html"},{"type":"module","doc":"","title":"AI.Tools.Git.ListBranches","ref":"AI.Tools.Git.ListBranches.html"},{"type":"module","doc":"","title":"AI.Tools.Git.Log","ref":"AI.Tools.Git.Log.html"},{"type":"module","doc":"","title":"AI.Tools.Git.Pickaxe","ref":"AI.Tools.Git.Pickaxe.html"},{"type":"module","doc":"","title":"AI.Tools.Git.Show","ref":"AI.Tools.Git.Show.html"},{"type":"module","doc":"","title":"AI.Tools.Git.UnstagedChanges","ref":"AI.Tools.Git.UnstagedChanges.html"},{"type":"module","doc":"","title":"AI.Tools.Research","ref":"AI.Tools.Research.html"},{"type":"module","doc":"","title":"AI.Tools.Ripgrep","ref":"AI.Tools.Ripgrep.html"},{"type":"function","doc":"This tool requires that ripgrep (rg) is installed and available in the PATH.","title":"AI.Tools.Ripgrep.is_available?/0","ref":"AI.Tools.Ripgrep.html#is_available?/0"},{"type":"module","doc":"","title":"AI.Util","ref":"AI.Util.html"},{"type":"function","doc":"Creates an assistant message object, representing the assistant's response.","title":"AI.Util.assistant_msg/1","ref":"AI.Util.html#assistant_msg/1"},{"type":"function","doc":"This is the tool call message, which must come immediately before the\n`tool_msg/3` message with the same `tool_call_id` (`id`).","title":"AI.Util.assistant_tool_msg/3","ref":"AI.Util.html#assistant_tool_msg/3"},{"type":"function","doc":"","title":"AI.Util.cosine_similarity/2","ref":"AI.Util.html#cosine_similarity/2"},{"type":"function","doc":"Builds a \"transcript\" of the research process by converting the messages into\ntext. This is most commonly used to generate a transcript of the research\nperformed in a conversation for various agents and tool calls.","title":"AI.Util.research_transcript/1","ref":"AI.Util.html#research_transcript/1"},{"type":"function","doc":"Creates a system message object, used to define the assistant's behavior for\nthe conversation.","title":"AI.Util.system_msg/1","ref":"AI.Util.html#system_msg/1"},{"type":"function","doc":"This is the tool outputs message, which must come immediately after the\n`assistant_tool_msg/3` message with the same `tool_call_id` (`id`).","title":"AI.Util.tool_msg/3","ref":"AI.Util.html#tool_msg/3"},{"type":"function","doc":"Creates a user message object, representing the user's input prompt.","title":"AI.Util.user_msg/1","ref":"AI.Util.html#user_msg/1"},{"type":"function","doc":"Extracts the user's *most recent* query from the conversation messages.","title":"AI.Util.user_query/1","ref":"AI.Util.html#user_query/1"},{"type":"behaviour","doc":"","title":"Cmd","ref":"Cmd.html"},{"type":"function","doc":"","title":"Cmd.default_workers/0","ref":"Cmd.html#default_workers/0"},{"type":"callback","doc":"","title":"Cmd.run/3","ref":"Cmd.html#c:run/3"},{"type":"callback","doc":"","title":"Cmd.spec/0","ref":"Cmd.html#c:spec/0"},{"type":"module","doc":"","title":"Cmd.Ask","ref":"Cmd.Ask.html"},{"type":"module","doc":"","title":"Cmd.Config","ref":"Cmd.Config.html"},{"type":"module","doc":"","title":"Cmd.Conversations","ref":"Cmd.Conversations.html"},{"type":"module","doc":"Converses with the default AI agent.\n\nConversations are a \"floating window\" of messages that are stored in the\ndefault project.","title":"Cmd.Default","ref":"Cmd.Default.html"},{"type":"module","doc":"","title":"Cmd.Files","ref":"Cmd.Files.html"},{"type":"module","doc":"","title":"Cmd.Frobs","ref":"Cmd.Frobs.html"},{"type":"module","doc":"","title":"Cmd.Index","ref":"Cmd.Index.html"},{"type":"function","doc":"","title":"Cmd.Index.index_project/1","ref":"Cmd.Index.html#index_project/1"},{"type":"function","doc":"","title":"Cmd.Index.new/1","ref":"Cmd.Index.html#new/1"},{"type":"function","doc":"","title":"Cmd.Index.perform_task/1","ref":"Cmd.Index.html#perform_task/1"},{"type":"module","doc":"","title":"Cmd.Notes","ref":"Cmd.Notes.html"},{"type":"module","doc":"","title":"Cmd.Projects","ref":"Cmd.Projects.html"},{"type":"module","doc":"","title":"Cmd.Replay","ref":"Cmd.Replay.html"},{"type":"module","doc":"","title":"Cmd.Search","ref":"Cmd.Search.html"},{"type":"module","doc":"","title":"Cmd.Summary","ref":"Cmd.Summary.html"},{"type":"module","doc":"","title":"Cmd.Tool","ref":"Cmd.Tool.html"},{"type":"module","doc":"","title":"Cmd.Torch","ref":"Cmd.Torch.html"},{"type":"function","doc":"Permanently deletes the project from the store.","title":"Cmd.Torch.run/3","ref":"Cmd.Torch.html#run/3"},{"type":"module","doc":"","title":"Cmd.Upgrade","ref":"Cmd.Upgrade.html"},{"type":"module","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and\nsearch code files.","title":"Fnord","ref":"Fnord.html"},{"type":"function","doc":"","title":"Fnord.configure_logger/0","ref":"Fnord.html#configure_logger/0"},{"type":"function","doc":"Main entry point for the application. Parses command line arguments and\ndispatches to the appropriate subcommand.","title":"Fnord.main/1","ref":"Fnord.html#main/1"},{"type":"function","doc":"","title":"Fnord.spec/0","ref":"Fnord.html#spec/0"},{"type":"module","doc":"Frobs are external tool call integrations. They allow users to define\nexternal actions that can be executed by the LLM while researching the user's\nquery.\n\nFrobs are stored in `$HOME/.fnord/tools/$frob_name` and are composed of:\n- `registry.json`:  A JSON file that registers the frob for the user's projects\n- `spec.json`:      A JSON file that defines the tool call's calling semantics\n- `main`:           A script or binary that performs the action\n\nThe `registry.json` file contains the following fields:\n```json\n{\n  // When true, the frob is available to all projects and the \"projects\"\n  // field is ignored.\n  \"global\": true,\n\n  // An array of project names for which fnord should make the frob\n  // available. Superseded by the \"global\" field when set to true.\n  \"projects\": [\"my_project\", \"other_project\"]\n}\n```\n\nThe \"name\" field in `spec.json` is used to register the frob with the LLM.\nThis name must match the frob's directory name.\n\nIf desired, the user can add a lib/util/etc directory to hold any utility or\nhelper code to be used by `main`.\n\nFnord communicates run-time information to the frob via environment variables:\n- FNORD_PROJECT     # The name of the currently selected project\n- FNORD_CONFIG      # JSON object of project config\n- FNORD_ARGS_JSON   # JSON object of LLM-provided arguments","title":"Frobs","ref":"Frobs.html"},{"type":"function","doc":"","title":"Frobs.create/1","ref":"Frobs.html#create/1"},{"type":"function","doc":"","title":"Frobs.create_tool_module/1","ref":"Frobs.html#create_tool_module/1"},{"type":"function","doc":"","title":"Frobs.create_tool_module/2","ref":"Frobs.html#create_tool_module/2"},{"type":"function","doc":"","title":"Frobs.list/0","ref":"Frobs.html#list/0"},{"type":"function","doc":"","title":"Frobs.list/1","ref":"Frobs.html#list/1"},{"type":"function","doc":"","title":"Frobs.load/1","ref":"Frobs.html#load/1"},{"type":"function","doc":"","title":"Frobs.module_map/1","ref":"Frobs.html#module_map/1"},{"type":"function","doc":"","title":"Frobs.perform_tool_call/2","ref":"Frobs.html#perform_tool_call/2"},{"type":"type","doc":"","title":"Frobs.t/0","ref":"Frobs.html#t:t/0"},{"type":"module","doc":"Module for interacting with git.","title":"Git","ref":"Git.html"},{"type":"function","doc":"","title":"Git.base_commit/2","ref":"Git.html#base_commit/2"},{"type":"function","doc":"","title":"Git.current_branch/0","ref":"Git.html#current_branch/0"},{"type":"function","doc":"","title":"Git.diff_branch/2","ref":"Git.html#diff_branch/2"},{"type":"function","doc":"","title":"Git.git_diff/1","ref":"Git.html#git_diff/1"},{"type":"function","doc":"","title":"Git.git_log/1","ref":"Git.html#git_log/1"},{"type":"function","doc":"","title":"Git.git_root/0","ref":"Git.html#git_root/0"},{"type":"function","doc":"","title":"Git.grep/2","ref":"Git.html#grep/2"},{"type":"function","doc":"","title":"Git.ignored_dirs/0","ref":"Git.html#ignored_dirs/0"},{"type":"function","doc":"","title":"Git.ignored_dirs/1","ref":"Git.html#ignored_dirs/1"},{"type":"function","doc":"","title":"Git.ignored_files/0","ref":"Git.html#ignored_files/0"},{"type":"function","doc":"","title":"Git.ignored_files/1","ref":"Git.html#ignored_files/1"},{"type":"function","doc":"","title":"Git.is_git_repo?/0","ref":"Git.html#is_git_repo?/0"},{"type":"function","doc":"","title":"Git.is_git_repo?/1","ref":"Git.html#is_git_repo?/1"},{"type":"function","doc":"","title":"Git.is_ignored?/1","ref":"Git.html#is_ignored?/1"},{"type":"function","doc":"","title":"Git.is_ignored?/2","ref":"Git.html#is_ignored?/2"},{"type":"function","doc":"","title":"Git.list_branches/0","ref":"Git.html#list_branches/0"},{"type":"function","doc":"","title":"Git.pickaxe_regex/1","ref":"Git.html#pickaxe_regex/1"},{"type":"function","doc":"","title":"Git.show/1","ref":"Git.html#show/1"},{"type":"function","doc":"","title":"Git.show/2","ref":"Git.html#show/2"},{"type":"module","doc":"","title":"Http","ref":"Http.html"},{"type":"type","doc":"","title":"Http.headers/0","ref":"Http.html#t:headers/0"},{"type":"type","doc":"","title":"Http.http_error/0","ref":"Http.html#t:http_error/0"},{"type":"type","doc":"","title":"Http.http_status/0","ref":"Http.html#t:http_status/0"},{"type":"type","doc":"","title":"Http.options/0","ref":"Http.html#t:options/0"},{"type":"type","doc":"","title":"Http.payload/0","ref":"Http.html#t:payload/0"},{"type":"function","doc":"Sends a POST request with a JSON payload to the specified URL with the given\nheaders. Returns a tuple with the response status and body, or an error if\nthe request fails.","title":"Http.post_json/3","ref":"Http.html#post_json/3"},{"type":"type","doc":"","title":"Http.response/0","ref":"Http.html#t:response/0"},{"type":"type","doc":"","title":"Http.success/0","ref":"Http.html#t:success/0"},{"type":"type","doc":"","title":"Http.transport_error/0","ref":"Http.html#t:transport_error/0"},{"type":"type","doc":"","title":"Http.url/0","ref":"Http.html#t:url/0"},{"type":"behaviour","doc":"This behaviour wraps the AI-powered operations used by `Cmd.Index` to allow\noverrides for testing. See `impl/0`.","title":"Indexer","ref":"Indexer.html"},{"type":"type","doc":"","title":"Indexer.completion/0","ref":"Indexer.html#t:completion/0"},{"type":"type","doc":"","title":"Indexer.embeddings/0","ref":"Indexer.html#t:embeddings/0"},{"type":"type","doc":"","title":"Indexer.error/0","ref":"Indexer.html#t:error/0"},{"type":"type","doc":"","title":"Indexer.file_content/0","ref":"Indexer.html#t:file_content/0"},{"type":"type","doc":"","title":"Indexer.file_path/0","ref":"Indexer.html#t:file_path/0"},{"type":"callback","doc":"","title":"Indexer.get_embeddings/1","ref":"Indexer.html#c:get_embeddings/1"},{"type":"callback","doc":"","title":"Indexer.get_outline/2","ref":"Indexer.html#c:get_outline/2"},{"type":"callback","doc":"","title":"Indexer.get_summary/2","ref":"Indexer.html#c:get_summary/2"},{"type":"function","doc":"Returns the current indexer module. This can be overridden by config for unit\ntesting. See `test/test_helper.exs`.","title":"Indexer.impl/0","ref":"Indexer.html#impl/0"},{"type":"type","doc":"","title":"Indexer.indexer/0","ref":"Indexer.html#t:indexer/0"},{"type":"module","doc":"","title":"Once","ref":"Once.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"Once.child_spec/1","ref":"Once.html#child_spec/1"},{"type":"function","doc":"Callback implementation for  GenServer.init/1 .","title":"Once.init/1","ref":"Once.html#init/1"},{"type":"function","doc":"","title":"Once.start_link/1","ref":"Once.html#start_link/1"},{"type":"function","doc":"","title":"Once.warn/1","ref":"Once.html#warn/1"},{"type":"module","doc":"","title":"Search","ref":"Search.html"},{"type":"function","doc":"","title":"Search.get_results/1","ref":"Search.html#get_results/1"},{"type":"function","doc":"","title":"Search.new/1","ref":"Search.html#new/1"},{"type":"module","doc":"","title":"Settings","ref":"Settings.html"},{"type":"function","doc":"Delete a value from the settings store.","title":"Settings.delete/2","ref":"Settings.html#delete/2"},{"type":"function","doc":"Get a value from the settings store.","title":"Settings.get/3","ref":"Settings.html#get/3"},{"type":"function","doc":"","title":"Settings.get_project/1","ref":"Settings.html#get_project/1"},{"type":"function","doc":"","title":"Settings.get_root/1","ref":"Settings.html#get_root/1"},{"type":"function","doc":"Get the project specified with --project. If the project name is not set, an\nerror will be raised.","title":"Settings.get_selected_project!/0","ref":"Settings.html#get_selected_project!/0"},{"type":"function","doc":"Get the path to the store root directory.","title":"Settings.home/0","ref":"Settings.html#home/0"},{"type":"function","doc":"","title":"Settings.list_projects/1","ref":"Settings.html#list_projects/1"},{"type":"function","doc":"","title":"Settings.new/0","ref":"Settings.html#new/0"},{"type":"function","doc":"Set a value in the settings store.","title":"Settings.set/3","ref":"Settings.html#set/3"},{"type":"function","doc":"","title":"Settings.set_project/2","ref":"Settings.html#set_project/2"},{"type":"function","doc":"Get the path to the settings file. If the file does not exist, it will be\ncreated.","title":"Settings.settings_file/0","ref":"Settings.html#settings_file/0"},{"type":"type","doc":"","title":"Settings.t/0","ref":"Settings.html#t:t/0"},{"type":"module","doc":"","title":"Spinner","ref":"Spinner.html"},{"type":"function","doc":"","title":"Spinner.run/2","ref":"Spinner.html#run/2"},{"type":"module","doc":"","title":"Store","ref":"Store.html"},{"type":"function","doc":"","title":"Store.get_project/0","ref":"Store.html#get_project/0"},{"type":"function","doc":"","title":"Store.get_project/1","ref":"Store.html#get_project/1"},{"type":"function","doc":"","title":"Store.get_project_home/1","ref":"Store.html#get_project_home/1"},{"type":"function","doc":"","title":"Store.store_home/0","ref":"Store.html#store_home/0"},{"type":"module","doc":"","title":"Store.DefaultProject","ref":"Store.DefaultProject.html"},{"type":"function","doc":"","title":"Store.DefaultProject.store_path/0","ref":"Store.DefaultProject.html#store_path/0"},{"type":"module","doc":"","title":"Store.DefaultProject.Conversation","ref":"Store.DefaultProject.Conversation.html"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.add_messages/1","ref":"Store.DefaultProject.Conversation.html#add_messages/1"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.add_timestamp/0","ref":"Store.DefaultProject.Conversation.html#add_timestamp/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.file_path/0","ref":"Store.DefaultProject.Conversation.html#file_path/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.last_interaction/0","ref":"Store.DefaultProject.Conversation.html#last_interaction/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.latest_timestamp/0","ref":"Store.DefaultProject.Conversation.html#latest_timestamp/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.read_file/0","ref":"Store.DefaultProject.Conversation.html#read_file/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.read_messages/0","ref":"Store.DefaultProject.Conversation.html#read_messages/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Conversation.replace_messages/1","ref":"Store.DefaultProject.Conversation.html#replace_messages/1"},{"type":"module","doc":"","title":"Store.DefaultProject.Notes","ref":"Store.DefaultProject.Notes.html"},{"type":"function","doc":"","title":"Store.DefaultProject.Notes.build/0","ref":"Store.DefaultProject.Notes.html#build/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Notes.create/1","ref":"Store.DefaultProject.Notes.html#create/1"},{"type":"function","doc":"","title":"Store.DefaultProject.Notes.delete/1","ref":"Store.DefaultProject.Notes.html#delete/1"},{"type":"function","doc":"","title":"Store.DefaultProject.Notes.file_path/0","ref":"Store.DefaultProject.Notes.html#file_path/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Notes.read/0","ref":"Store.DefaultProject.Notes.html#read/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Notes.search/1","ref":"Store.DefaultProject.Notes.html#search/1"},{"type":"function","doc":"","title":"Store.DefaultProject.Notes.update/2","ref":"Store.DefaultProject.Notes.html#update/2"},{"type":"module","doc":"","title":"Store.DefaultProject.Prompt","ref":"Store.DefaultProject.Prompt.html"},{"type":"function","doc":"","title":"Store.DefaultProject.Prompt.build/0","ref":"Store.DefaultProject.Prompt.html#build/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Prompt.create/1","ref":"Store.DefaultProject.Prompt.html#create/1"},{"type":"function","doc":"","title":"Store.DefaultProject.Prompt.delete/1","ref":"Store.DefaultProject.Prompt.html#delete/1"},{"type":"function","doc":"","title":"Store.DefaultProject.Prompt.file_path/0","ref":"Store.DefaultProject.Prompt.html#file_path/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Prompt.read/0","ref":"Store.DefaultProject.Prompt.html#read/0"},{"type":"function","doc":"","title":"Store.DefaultProject.Prompt.update/2","ref":"Store.DefaultProject.Prompt.html#update/2"},{"type":"module","doc":"","title":"Store.Project","ref":"Store.Project.html"},{"type":"function","doc":"","title":"Store.Project.conversations/1","ref":"Store.Project.html#conversations/1"},{"type":"function","doc":"","title":"Store.Project.create/1","ref":"Store.Project.html#create/1"},{"type":"function","doc":"","title":"Store.Project.delete/1","ref":"Store.Project.html#delete/1"},{"type":"function","doc":"","title":"Store.Project.delete_missing_files/1","ref":"Store.Project.html#delete_missing_files/1"},{"type":"function","doc":"","title":"Store.Project.exists_in_store?/1","ref":"Store.Project.html#exists_in_store?/1"},{"type":"function","doc":"","title":"Store.Project.expand_path/2","ref":"Store.Project.html#expand_path/2"},{"type":"function","doc":"","title":"Store.Project.find_entry/2","ref":"Store.Project.html#find_entry/2"},{"type":"function","doc":"","title":"Store.Project.find_file/2","ref":"Store.Project.html#find_file/2"},{"type":"function","doc":"","title":"Store.Project.find_path_in_source_root/2","ref":"Store.Project.html#find_path_in_source_root/2"},{"type":"function","doc":"","title":"Store.Project.has_index?/1","ref":"Store.Project.html#has_index?/1"},{"type":"function","doc":"","title":"Store.Project.make_default_for_session/1","ref":"Store.Project.html#make_default_for_session/1"},{"type":"function","doc":"","title":"Store.Project.new/2","ref":"Store.Project.html#new/2"},{"type":"function","doc":"","title":"Store.Project.relative_path/2","ref":"Store.Project.html#relative_path/2"},{"type":"function","doc":"","title":"Store.Project.save_settings/3","ref":"Store.Project.html#save_settings/3"},{"type":"function","doc":"","title":"Store.Project.source_files/1","ref":"Store.Project.html#source_files/1"},{"type":"function","doc":"","title":"Store.Project.stored_files/1","ref":"Store.Project.html#stored_files/1"},{"type":"type","doc":"","title":"Store.Project.t/0","ref":"Store.Project.html#t:t/0"},{"type":"function","doc":"","title":"Store.Project.torch/1","ref":"Store.Project.html#torch/1"},{"type":"module","doc":"Conversations are stored per project in the project's store dir, under\n`converations/`. Each conversation is given a UUID identifier and stored as a\nJSON file with the keys:\n  - `messages`: a list of messages in the conversation\n  - `timestamp`: the time the conversation was last written to\n\nExisting conversations are retrieved by their UUID identifier.","title":"Store.Project.Conversation","ref":"Store.Project.Conversation.html"},{"type":"function","doc":"Deletes the conversation from the store. If the conversation does not exist,\nreturns an error tuple.","title":"Store.Project.Conversation.delete/1","ref":"Store.Project.Conversation.html#delete/1"},{"type":"function","doc":"Returns true if the conversation exists on disk, false otherwise.","title":"Store.Project.Conversation.exists?/1","ref":"Store.Project.Conversation.html#exists?/1"},{"type":"function","doc":"Lists all conversations in the given project.","title":"Store.Project.Conversation.list/1","ref":"Store.Project.Conversation.html#list/1"},{"type":"function","doc":"Create a new conversation with a new UUID identifier and the globally\nselected project.","title":"Store.Project.Conversation.new/0","ref":"Store.Project.Conversation.html#new/0"},{"type":"function","doc":"Create a new conversation from an existing UUID identifier and the globally\nselected project.","title":"Store.Project.Conversation.new/1","ref":"Store.Project.Conversation.html#new/1"},{"type":"function","doc":"Create a new conversation from an existing UUID identifier and an explicitly\nspecified project.","title":"Store.Project.Conversation.new/2","ref":"Store.Project.Conversation.html#new/2"},{"type":"function","doc":"Returns the user's prompting message in the conversation. This is considered\nto be the first \"user\" role message in the conversation.","title":"Store.Project.Conversation.question/1","ref":"Store.Project.Conversation.html#question/1"},{"type":"function","doc":"Reads the conversation from the store. Returns a tuple with the timestamp and\nthe messages in the conversation.","title":"Store.Project.Conversation.read/1","ref":"Store.Project.Conversation.html#read/1"},{"type":"type","doc":"","title":"Store.Project.Conversation.t/0","ref":"Store.Project.Conversation.html#t:t/0"},{"type":"function","doc":"Returns the timestamp of the conversation. If the conversation has not yet\nbeen saved to the store, returns 0.","title":"Store.Project.Conversation.timestamp/1","ref":"Store.Project.Conversation.html#timestamp/1"},{"type":"function","doc":"Saves the conversation in the store. The conversation's timestamp is updated\nto the current time.","title":"Store.Project.Conversation.write/2","ref":"Store.Project.Conversation.html#write/2"},{"type":"module","doc":"","title":"Store.Project.Entry","ref":"Store.Project.Entry.html"},{"type":"function","doc":"","title":"Store.Project.Entry.create/1","ref":"Store.Project.Entry.html#create/1"},{"type":"function","doc":"","title":"Store.Project.Entry.delete/1","ref":"Store.Project.Entry.html#delete/1"},{"type":"function","doc":"","title":"Store.Project.Entry.embeddings_file_paths/1","ref":"Store.Project.Entry.html#embeddings_file_paths/1"},{"type":"function","doc":"","title":"Store.Project.Entry.exists_in_store?/1","ref":"Store.Project.Entry.html#exists_in_store?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.has_embeddings?/1","ref":"Store.Project.Entry.html#has_embeddings?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.has_metadata?/1","ref":"Store.Project.Entry.html#has_metadata?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.has_outline?/1","ref":"Store.Project.Entry.html#has_outline?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.has_summary?/1","ref":"Store.Project.Entry.html#has_summary?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.hash_is_current?/1","ref":"Store.Project.Entry.html#hash_is_current?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.is_incomplete?/1","ref":"Store.Project.Entry.html#is_incomplete?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.is_stale?/1","ref":"Store.Project.Entry.html#is_stale?/1"},{"type":"function","doc":"","title":"Store.Project.Entry.metadata_file_path/1","ref":"Store.Project.Entry.html#metadata_file_path/1"},{"type":"function","doc":"","title":"Store.Project.Entry.new_from_entry_path/2","ref":"Store.Project.Entry.html#new_from_entry_path/2"},{"type":"function","doc":"","title":"Store.Project.Entry.new_from_file_path/2","ref":"Store.Project.Entry.html#new_from_file_path/2"},{"type":"function","doc":"","title":"Store.Project.Entry.outline_file_path/1","ref":"Store.Project.Entry.html#outline_file_path/1"},{"type":"function","doc":"","title":"Store.Project.Entry.read/1","ref":"Store.Project.Entry.html#read/1"},{"type":"function","doc":"","title":"Store.Project.Entry.read_embeddings/1","ref":"Store.Project.Entry.html#read_embeddings/1"},{"type":"function","doc":"","title":"Store.Project.Entry.read_metadata/1","ref":"Store.Project.Entry.html#read_metadata/1"},{"type":"function","doc":"","title":"Store.Project.Entry.read_outline/1","ref":"Store.Project.Entry.html#read_outline/1"},{"type":"function","doc":"","title":"Store.Project.Entry.read_source_file/1","ref":"Store.Project.Entry.html#read_source_file/1"},{"type":"function","doc":"","title":"Store.Project.Entry.read_summary/1","ref":"Store.Project.Entry.html#read_summary/1"},{"type":"function","doc":"","title":"Store.Project.Entry.save/4","ref":"Store.Project.Entry.html#save/4"},{"type":"function","doc":"","title":"Store.Project.Entry.save_embeddings/2","ref":"Store.Project.Entry.html#save_embeddings/2"},{"type":"function","doc":"","title":"Store.Project.Entry.save_metadata/1","ref":"Store.Project.Entry.html#save_metadata/1"},{"type":"function","doc":"","title":"Store.Project.Entry.save_outline/2","ref":"Store.Project.Entry.html#save_outline/2"},{"type":"function","doc":"","title":"Store.Project.Entry.save_summary/2","ref":"Store.Project.Entry.html#save_summary/2"},{"type":"function","doc":"","title":"Store.Project.Entry.summary_file_path/1","ref":"Store.Project.Entry.html#summary_file_path/1"},{"type":"type","doc":"","title":"Store.Project.Entry.t/0","ref":"Store.Project.Entry.html#t:t/0"},{"type":"module","doc":"","title":"Store.Project.Entry.Embeddings","ref":"Store.Project.Entry.Embeddings.html"},{"type":"module","doc":"","title":"Store.Project.Entry.Metadata","ref":"Store.Project.Entry.Metadata.html"},{"type":"module","doc":"","title":"Store.Project.Entry.Outline","ref":"Store.Project.Entry.Outline.html"},{"type":"module","doc":"","title":"Store.Project.Entry.Summary","ref":"Store.Project.Entry.Summary.html"},{"type":"behaviour","doc":"","title":"Store.Project.EntryFile","ref":"Store.Project.EntryFile.html"},{"type":"callback","doc":"","title":"Store.Project.EntryFile.exists?/1","ref":"Store.Project.EntryFile.html#c:exists?/1"},{"type":"callback","doc":"","title":"Store.Project.EntryFile.new/2","ref":"Store.Project.EntryFile.html#c:new/2"},{"type":"callback","doc":"","title":"Store.Project.EntryFile.read/1","ref":"Store.Project.EntryFile.html#c:read/1"},{"type":"callback","doc":"","title":"Store.Project.EntryFile.store_path/1","ref":"Store.Project.EntryFile.html#c:store_path/1"},{"type":"callback","doc":"","title":"Store.Project.EntryFile.write/2","ref":"Store.Project.EntryFile.html#c:write/2"},{"type":"module","doc":"","title":"Store.Project.Notes","ref":"Store.Project.Notes.html"},{"type":"function","doc":"","title":"Store.Project.Notes.read/1","ref":"Store.Project.Notes.html#read/1"},{"type":"function","doc":"","title":"Store.Project.Notes.reset/1","ref":"Store.Project.Notes.html#reset/1"},{"type":"function","doc":"","title":"Store.Project.Notes.write/2","ref":"Store.Project.Notes.html#write/2"},{"type":"module","doc":"","title":"Timed","ref":"Timed.html"},{"type":"function","doc":"","title":"Timed.timed/2","ref":"Timed.html#timed/2"},{"type":"module","doc":"","title":"UI","ref":"UI.html"},{"type":"function","doc":"","title":"UI.async_stream/4","ref":"UI.html#async_stream/4"},{"type":"function","doc":"","title":"UI.begin_step/2","ref":"UI.html#begin_step/2"},{"type":"function","doc":"","title":"UI.confirm/1","ref":"UI.html#confirm/1"},{"type":"function","doc":"","title":"UI.confirm/2","ref":"UI.html#confirm/2"},{"type":"function","doc":"","title":"UI.debug/1","ref":"UI.html#debug/1"},{"type":"function","doc":"","title":"UI.debug/2","ref":"UI.html#debug/2"},{"type":"function","doc":"","title":"UI.end_step/2","ref":"UI.html#end_step/2"},{"type":"function","doc":"","title":"UI.error/1","ref":"UI.html#error/1"},{"type":"function","doc":"","title":"UI.error/2","ref":"UI.html#error/2"},{"type":"function","doc":"","title":"UI.fatal/1","ref":"UI.html#fatal/1"},{"type":"function","doc":"","title":"UI.fatal/2","ref":"UI.html#fatal/2"},{"type":"function","doc":"","title":"UI.flush/0","ref":"UI.html#flush/0"},{"type":"function","doc":"","title":"UI.info/1","ref":"UI.html#info/1"},{"type":"function","doc":"","title":"UI.info/2","ref":"UI.html#info/2"},{"type":"function","doc":"","title":"UI.is_tty?/0","ref":"UI.html#is_tty?/0"},{"type":"function","doc":"","title":"UI.log_usage/2","ref":"UI.html#log_usage/2"},{"type":"function","doc":"","title":"UI.printf_debug/1","ref":"UI.html#printf_debug/1"},{"type":"function","doc":"","title":"UI.progress_bar_start/3","ref":"UI.html#progress_bar_start/3"},{"type":"function","doc":"","title":"UI.progress_bar_update/1","ref":"UI.html#progress_bar_update/1"},{"type":"function","doc":"","title":"UI.quiet?/0","ref":"UI.html#quiet?/0"},{"type":"function","doc":"","title":"UI.report_step/1","ref":"UI.html#report_step/1"},{"type":"function","doc":"","title":"UI.report_step/2","ref":"UI.html#report_step/2"},{"type":"function","doc":"","title":"UI.spin/2","ref":"UI.html#spin/2"},{"type":"function","doc":"","title":"UI.warn/1","ref":"UI.html#warn/1"},{"type":"function","doc":"","title":"UI.warn/2","ref":"UI.html#warn/2"},{"type":"module","doc":"","title":"Util","ref":"Util.html"},{"type":"function","doc":"","title":"Util.async_filter/2","ref":"Util.html#async_filter/2"},{"type":"function","doc":"Convenience wrapper for `Task.async_stream/3` with the default optiosn for\nconcurrency and timeout set to `Application.get_env(:fnord, :workers)` and\n`:infinity`, respectively.","title":"Util.async_stream/3","ref":"Util.html#async_stream/3"},{"type":"function","doc":"","title":"Util.format_number/1","ref":"Util.html#format_number/1"},{"type":"function","doc":"","title":"Util.get_latest_version/0","ref":"Util.html#get_latest_version/0"},{"type":"function","doc":"","title":"Util.get_running_version/0","ref":"Util.html#get_running_version/0"},{"type":"function","doc":"Converts all string keys in a map to atoms, recursively.","title":"Util.string_keys_to_atoms/1","ref":"Util.html#string_keys_to_atoms/1"},{"type":"extras","doc":"# Fnord\n\n[![Tests | Dialyzer](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\n- [Description](#description)\n- [Features](#features)\n- [Installation](#installation)\n- [Getting Started](#getting-started)\n- [Tool usage](#tool-usage)\n- [User integrations](#user-integrations)\n- [Copyright and License](#copyright-and-license)","title":"Fnord","ref":"readme.html"},{"type":"extras","doc":"`fnord` is a command line tool that uses multiple LLM-powered agents and tools to provide a conversational interface to your codebase, notes, and other (non-binary) files.\n\nIt can be used to generate on-demand tutorials, playbooks, and documentation for your project, as well as to search for examples, explanations, and solutions to problems in your codebase.","title":"Description - Fnord","ref":"readme.html#description"},{"type":"extras","doc":"AI-powered tools are limited by to the data built into their training data. **RAG (Retrieval-Augmented Generation)** using tool calls can supplement the training data with information, such as your code base, to provide more accurate and relevant answers to your questions.\n\nBut even with RAG, the AI still runs up against the **context window**. This is the conversational \"memory\" of the AI, often making use of an \"attention mechanism\" to keep it focused on the current instructions, but causing it to lose track of details earlier in the conversation.\n\nIf you've ever pasted multiple files into ChatGPT or worked with it iteratively on a piece of code, you've probably seen this in action. It may forget constraints you defined earlier in the conversation or hallucinate entities and functions that don't exist in any of the files you've shown it.\n\n`fnord` attempts to mitigate this with cleverly designed tool calls that allow the LLM to ask _other_ agents to perform tasks on its behalf. For example, it can generate a prompt to ask another agent to read through a file and retrieve specific details it needs, like a single function definition, the declaration of an interface, or whether a specific function behaves in a certain way. This keeps the entire file out of the \"coordinating\" agent's context window while still allowing it to use the information in the file to generate a response. This allows `fnord` to conduct more complex research across many files and directories without losing track of the details it needs to provide accurate answers.","title":"Why fnord? - Fnord","ref":"readme.html#why-fnord"},{"type":"extras","doc":"- Semantic search\n- On-demand explanations, documentation, and tutorials\n- Git archaeology\n- Learns about your project(s) over time\n- Improves its research capabilities with each interaction\n- User integrations","title":"Features - Fnord","ref":"readme.html#features"},{"type":"extras","doc":"Fnord is written in [Elixir](https://elixir-lang.org/) and is distributed as an `escript`.\n\n- **Install [elixir](https://elixir-lang.org/)**\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n- **Add the `escript` path to your shell's PATH**\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n- **Install `fnord`**\n```bash\nmix escript.install github sysread/fnord\n```\n\n- **Set `OPENAI_API_KEY` in your shell environment**\n\nSet this in your shell environment to the OpenAI project key you wish to use for this tool.\nYou can create a new project and get a key [here](https://platform.openai.com/api-keys).\n\n\n- **Optional: Install `ripgrep`**\n\n`fnord` includes tooling for the LLM to use the `ripgrep` tool in addition to semantic search.\nThis enables the LLM to answer questions about your code base, even if the project has not been indexed yet (with the caveat that the results will be less context-aware).\n\n\n- **Optional: Install a markdown viewer**\n\nMarkdown seems to be the language of choice for LLMs, so installing something like `glow` to pipe output to will make the output more readable.","title":"Installation - Fnord","ref":"readme.html#installation"},{"type":"extras","doc":"For the purposes of this guide, we will assume that `fnord` is installed and we are using it to interact with your project, `blarg`, which is located at `$HOME/dev/blarg`.","title":"Getting Started - Fnord","ref":"readme.html#getting-started"},{"type":"extras","doc":"The first step is to index your project to make it searchable with `fnord`'s semantic search capabilities.\nThe first time you index your project may take a while, especially if there are a lot of files.\n`fnord` respects `.gitignore`, but you may also wish to exclude certain paths or globs from indexing (e.g., `-x 'node_modules'`).\n\n```bash\nfnord index --project blarg --dir $HOME/dev/blarg --exclude 'node_modules'\n```\n\nIf you cancel partway-through (for example, with `Ctrl-C`), you can resume indexing by running the same command again.\n\nYou must re-index your project to reflect changes in the code base, new files, deleted files, or to change the directory or exclusions.\nThis is done by running the same command again.\n\n`fnord` stores its index in `$HOME/.fnord/$project`.\n\nAlthough indexing provides full semantic search capabilities and richer results, `fnord` also supports ad-hoc querying on unindexed projects via directory metadata and `ripgrep` fallback, allowing quicker experimentation without full indexing.","title":"Index your project - Fnord","ref":"readme.html#index-your-project"},{"type":"extras","doc":"You can view and edit the configuration for your project with the `fnord config` command.\n\n```bash\nfnord config list --project blarg\nfnord config set --project blarg --root $HOME/dev/blarg --exclude 'node_modules' --exclude 'vendor'\n```","title":"Configuration - Fnord","ref":"readme.html#configuration"},{"type":"extras","doc":"`fnord`'s semantic search is powered by embeddings generated by OpenAI's `text-embedding-3-large` model. The indexing process does a lot more than simply generate embeddings for the contents of your files. It also generates summary documentation for each file as well as an index of all functions, entities, and symbols in each file to enhance semantic matches for common questions and symbols.\n\n```bash\nfnord search --project blarg --query \"callers of some_function\"\nfnord search --project blarg --query \"some_function definition\"\nfnord search --project blarg --query \"unit tests for some_function\"\n```\n\nThe summaries generated by the indexing process can also be included in the search results with the `--detail` flag.\n\n```bash\nfnord search --project blarg --query \"some_function declaration\" --detail | glow\n```\n\nIf you would like to see more information about a single file, you can use the `summary` command.\n\n```bash\nfnord summary --project blarg --file \"path/to/some_module.ext\" | glow\n```","title":"Search your code base - Fnord","ref":"readme.html#search-your-code-base"},{"type":"extras","doc":"`fnord` uses semantic search by default when a project has been indexed. If semantic search is unavailable (because the project is unindexed or the index is missing):\n\n- Semantic search will be disabled with a warning.\n- If `ripgrep` is installed and in your PATH, `fnord` will automatically fall back to ripgrep for basic text-based file search.\n- If ripgrep is not available, you will see a warning indicating limited search capability.\n- This fallback behavior lets you query projects immediately without waiting for a full index, providing fast albeit less context-aware results.","title":"Search behavior and fallbacks - Fnord","ref":"readme.html#search-behavior-and-fallbacks"},{"type":"extras","doc":"`fnord` uses a combination of LLM-powered agents and tool calls to research your question within your project, including access to semantic search and git tools (read only!).\n\nAs it conducts its investigation, you will see some of the research steps reported back to you in real-time. These are printed to `STDERR` so they will not interfere with redirected output. If you wish to see more of this, set `LOGGER_LEVEL=debug` in your shell.\n\n```bash\nfnord ask --project blarg --question \"Where is the unit test for some_function?\"\nfnord ask --project blarg --question \"Find all callers of some_function\"\nfnord ask --project blarg --question \"Is there a function or method that does X?\"\nfnord ask --project blarg --question \"How do I add a new X implementation?\"\n```\n\n#### Asking questions without prior indexing\n\nYou can now use `fnord ask` on projects that have **not yet been indexed** or where the project index is unavailable.\n\n- If the project is already created in `fnord` but not indexed, semantic search will be disabled, and `ripgrep` fallback will be used if available.\n- If the project does **not exist in fnord yet**, you can provide the project's root directory with the `--directory` (or `-d`) option when running `fnord ask`.\n- This will automatically create the project metadata on demand and allow you to query the project files without requiring a full index upfront.\n\nExample usage:\n\n```bash\n# Ask a question about a project without an index by specifying the source directory\nfnord ask --project blarg --directory $HOME/dev/blarg --question \"Where is the unit test for some_function?\"\n\n# Continue to specify the directory if the project has not been indexed or created yet\nfnord ask --project new_project --directory /path/to/new_project --question \"Explain the main workflow\"\n```\n\nNote: If semantic search is unavailable and `ripgrep` is not installed, you will receive a warning and limited search capability. To get full semantic search power, please index your project using the `fnord index` command.\n\n#### Improve research quality\n\nBy default, `ask` performs a single round of research (multiple tool calls per round notwithstanding).\nYou can increase the number of rounds with the `--rounds` option.\nIncreasing the number of rounds will increase the time it takes to generate a response, but can drastically improve the quality and thoroughness of the response, especially in large code bases or code bases containing multiple apps.\n\n```bash\nfnord ask --project blarg --question \"Please confirm that all information in the README is up-to-date and correct. Identify user-facing functionality that is not well-documented.\" --rounds 3\n```\n\n#### Continuing a conversation\n\nConversations (the transcript of messages between the LLM and the application) are saved for future reference and continuation. After each response, you will see a message like:\n```\nConversation saved with ID: c81928aa-6ab2-4346-9b2a-0edce6a639f0\n```\n\nIf desired, you can use that ID to continue the conversation with `--follow`.\n\n```bash\nfnord ask --project blarg --follow c81928aa-6ab2-4346-9b2a-0edce6a639f0 --question \"Is some_function still used?\"\n```\n\nList conversations with the `conversations` command.\n\n```bash\nfnord conversations --project blarg\n```\n\nPrune conversations older than a certain number of days with the `--prune` option.\n\n```bash\n# Prune conversations older than 30 days\nfnord conversations --project blarg --prune 30\n```\n\n#### Replaying a conversation\n\nYou can also `replay` a conversation, replicating the output of the original question, research steps, and response.\n\n```bash\nfnord replay --project blarg --conversation c81928aa-6ab2-4346-9b2a-0edce6a639f0 | glow\n```\n\nAs it learns more about your project, `fnord` will be able to answer more complex questions with less research.","title":"Generate answers on-demand - Fnord","ref":"readme.html#generate-answers-on-demand"},{"type":"extras","doc":"`fnord` learns about your project over time by saving facts and inferences it makes about the project while researching your questions. These facts and inferences are saved and made\nsearchable in the project's data in the `$HOME/.fnord` directory.\n\nYou can view the facts learned thus far, organized by topic, with the `notes` command.\n\n```bash\nfnord notes --project blarg | glow\n```\n\nOver time, these can become quite extensive, redundant, and stale over time as your code base evolves.\n\n`fnord` knows how to \"prime the pump\" for its learning process with an initial set of learnings.\n\n```bash\nfnord ask --project blarg --question \"Prime your research notes and report your findings\"\n```","title":"Learning over time - Fnord","ref":"readme.html#learning-over-time"},{"type":"extras","doc":"`fnord` is under active development and new features are added regularly. To upgrade to the latest version, simply run:\n\n```bash\nfnord upgrade\n```\n\nNote that this is just a shortcut for:\n\n```bash\nmix escript.install github sysread/fnord\n```","title":"Upgrades - Fnord","ref":"readme.html#upgrades"},{"type":"extras","doc":"- **List projects:** `fnord projects`\n- **List files in a project:** `fnord files --project foo`\n- **Delete a project:** `fnord torch --project foo`","title":"Other commands - Fnord","ref":"readme.html#other-commands"},{"type":"extras","doc":"All of the tool calls available to `fnord` are available for external use via the `tool` subcommand.\n\n```bash\n# List available tools\nfnord help tool\n\n# Get help for a specific tool\nfnord tool --tool file_search_tool --help\n\n# Call the tool\nfnord tool --tool file_search_tool --project blarg --query \"some_function definition\"\nfnord tool --tool file_info_tool --project blarg --file \"path/to/some_module.ext\" --question \"What public functions are defined in this file?\"\n```","title":"Tool usage - Fnord","ref":"readme.html#tool-usage"},{"type":"extras","doc":"Users can create their own integrations, called **frobs**, that `fnord` can use as a tool call while researching.\nJust like built-in tools, these are usable through the `fnord tool` subcommand.\n\n```bash\n# Create a new integration\nfnord frobs create --name my_frob\n\n# Validate the frob\nfnord frobs check --name my_frob\n\n# List frobs\nfnord frobs list\n\n# List frobs that are registered for a project\nfnord frobs list --project blarg\n```\n\nFrobs are stored in `$HOME/fnord/tools` and are comprised of the following files:\n- `my_frob/registry.json` - a JSON file that identifies the projects for which the frob is available\n- `my_frob/spec.json` - a JSON file describing the frob's calling semantics in [OpenAI's function spec format](https://platform.openai.com/docs/guides/function-calling?api-mode=responses#defining-functions)\n- `my_frob/main` - a script or binary that performs the requested task\n\n**Make your tool available to your projects:** edit the `registry.json` file created when you ran `fnord frobs create` to include the project name(s) for which you want the frob to be available.\n\n```json\n{\n  // When true, the frob is available to all projects and the \"projects\" field is ignored.\n  \"global\": true,\n\n  // An array of project names for which fnord should make the frob available. Superseded by the \"global\" field when set to true.\n  \"projects\": [\"blarg\", \"some_other_project\"]\n}\n```\n\n**Implementing the frob:** the `main` file is a script or binary that implements the frob. `fnord` passes information to the frob via shell environment variables:\n\n- `FNORD_PROJECT`: The name of the currently selected project\n- `FNORD_CONFIG`: The project configuration from `$HOME/.fnord/settings.json` as a single JSON object\n- `FNORD_ARGS_JSON`: JSON object of LLM-provided arguments\n\n**Testing your frob:** if you prefix your `fnord ask` query with `testing:`, you can ask the LLM to test your frob to confirm it is working as expected.\n\n```bash\nfnord ask -p blarg -q \"testing: please confirm that the 'my_frob' tool is available to you\"\nfnord ask -p blarg -q \"testing: please make a call to 'my_frob' with the arguments 'foo' and 'bar' and report the results\"\n```","title":"User integrations - Fnord","ref":"readme.html#user-integrations"},{"type":"extras","doc":"This software is copyright (c) 2025 by Jeff Ober.\n\nThis is free software; you can redistribute it and/or modify it under the MIT License.","title":"Copyright and License - Fnord","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}